// AddChapter.h : main header file for the ADDCHAPTER application
//

#if !defined(AFX_ADDCHAPTER_H__678135C9_AB5F_4FDC_96AB_EF650C46C7F5__INCLUDED_)
#define AFX_ADDCHAPTER_H__678135C9_AB5F_4FDC_96AB_EF650C46C7F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#define PAL 1
#define NTSC 0
#define BLANK 0
#define CUSTOM 1
typedef unsigned char uchar;

#include "resource.h"		// main symbols
// MaxIFOlength 512KByte
#define MAXLENGTH 524288
#define MAXTITLES	200
#define MAXPGCS	    400

/////////////////////////////////////////////////////////////////////////////
// CAddChapterApp:
// See AddChapter.cpp for the implementation of this class
//

class CAddChapterApp : public CWinApp
{
public:
	CAddChapterApp();

	CString m_csInputPath,m_csBackupPath;
	CString m_csInputIFO,m_csInputVMG;
	BOOL	m_checkappend, m_checkpuops, m_checkonecell;

	int m_nTitles;

	BOOL	m_BAdd[MAXPGCS];
	int		m_nCells[MAXPGCS], m_nChapters[MAXPGCS], m_nPrograms[MAXPGCS]; // Per PGC
	int		m_nTChapters[MAXTITLES]; // Per Title
	DWORD	m_dwDuration[MAXPGCS],m_dwDurationLC[MAXPGCS];
	int		m_nInVTS[MAXPGCS], m_nInVMG[MAXPGCS];
	bool	m_bEntryPGC[MAXPGCS];
	CString	m_csCellPath;
	__int64	m_i64CustomSize;
	int		m_iCellType[MAXPGCS];
	__int64	m_i64CellSize[MAXPGCS];
	int		m_iStillTime[MAXPGCS];
	int		m_iNewVid[MAXPGCS];
	int		m_iNewVidUniq;
	int		m_nVTS, m_nVOBs, m_nPGCs;
	int		m_nNewVids,m_nNewIFOSec;
	int		m_nTotalNewIFOSec;
	int		m_nNewCustom,m_nNewBlank,m_iSectorsAdded;
//	int		m_nTotalNewVids,m_nTotalNewCustom,m_nTotalNewBlank;
	int		m_nChap,m_nChaptersToAdd;
	int		m_maxVOBid;
	bool	m_bAtLeastOneCustom,m_bAtLeastOneBlank;
	__int64 m_i64LBA;
	int		m_iCustomPTSDuration;
	DWORD	m_dwCustomDuration;


	uchar	m_pVTS[MAXLENGTH + 105*2048], m_pVMG[MAXLENGTH];
	__int64	m_i64VTSlen,m_i64VMGlen, m_i64VTSsize, m_i64LastVOBSize;
// VMG vars and pointers
	int		m_TT_SRPT, m_nTotalTitles;
// VTS vars and pointers
	int		m_VTS_PTT_SRPT,	m_VTS_PGCI,	m_VTS_C_ADT,m_VTS_VOBU_ADMAP, m_VTS_TMAPTI;
	int		m_VTSM_VOBU_ADMAP,m_VTSM_C_ADT,m_VTSM_PGCI_UT;
	int		m_iVideoAttr,m_iFormat;
	int		m_VTS_PGC[MAXPGCS],m_C_PBKT[MAXPGCS],m_C_POST[MAXPGCS],m_PGM_MAP[MAXPGCS];
	int		m_VTS_PTT[MAXPGCS],m_VTS_PTT_L[MAXPGCS];
	uchar	SimpleVob[2048*5];


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAddChapterApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL
	virtual int ReadIFOs();
	virtual int ProcessSingleIFO();
	virtual int ProcessIFO();
	virtual int ProcessVMG();
	virtual int ProcessVOB();
	virtual int BackupIFOs();
	virtual int WriteIFOs();
	virtual void IniMembers();
	virtual int ExitInstance();
	virtual int FillVTSvars();
	virtual void RemoveMenuPUOPS(uchar* pIFO);
	virtual CString VideoAttr();
	virtual void FillSimpleVob(); 

// Implementation

	//{{AFX_MSG(CAddChapterApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ADDCHAPTER_H__678135C9_AB5F_4FDC_96AB_EF650C46C7F5__INCLUDED_)
