// AddChapterDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sys/types.h>
#include <sys/stat.h>
#include "ToolTipDialog.h"
#include "AddChapter.h"
#include "AddChapterDlg.h"
#include "CustomCellDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern CString SelectFolder (CString csTitulo);
extern CAddChapterApp theApp;
extern CString FormatDuration(DWORD duration);
extern int DurationInSecs(DWORD dwDuration);
extern int readbuffer(uchar *caracter, FILE *in);
extern bool IsNav(uchar* buffer);
extern int GetNbytes(int nNumber,uchar* address);



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddChapterDlg dialog

CAddChapterDlg::CAddChapterDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CAddChapterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddChapterDlg)
	m_csEditoutput = _T("");
	m_csEditinput = _T("");
	m_checkappend = FALSE;
	m_checkpuops = TRUE;
	m_checkonecell = FALSE;
	m_csEditcustom = _T("");
	m_csEditvideo = _T("");
	m_checkbackup = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAddChapterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddChapterDlg)
	DDX_Control(pDX, IDC_COMBONUM, m_ComboNum);
	DDX_Control(pDX, IDC_LIST, m_CList);
	DDX_Text(pDX, IDC_EDITOUTPUT, m_csEditoutput);
	DDX_Text(pDX, IDC_EDITINPUT, m_csEditinput);
	DDX_Check(pDX, IDC_CHECKAPPEND, m_checkappend);
	DDX_Check(pDX, IDC_CHECKPUOPS, m_checkpuops);
	DDX_Check(pDX, IDC_CHECKONECELL, m_checkonecell);
	DDX_Text(pDX, IDC_EDITCUSTOM, m_csEditcustom);
	DDX_Text(pDX, IDC_EDITVIDEO, m_csEditvideo);
	DDX_Check(pDX, IDC_CHECKBACKUP, m_checkbackup);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAddChapterDlg, CDialog)
	//{{AFX_MSG_MAP(CAddChapterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTONAUTO, OnButtonauto)
	ON_BN_CLICKED(IDC_BUTTONOUTPUT, OnButtonoutput)
	ON_BN_CLICKED(IDC_BUTTONINPUT, OnButtoninput)
	ON_NOTIFY(NM_CLICK, IDC_LIST, OnClickList)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST, OnDblclkList)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST, OnItemchangedList)
	ON_BN_CLICKED(IDC_BUTTONCUSTOM, OnButtoncustom)
	ON_BN_CLICKED(IDC_CHECKBACKUP, OnCheckbackup)
	//}}AFX_MSG_MAP

    ON_WM_DROPFILES()

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddChapterDlg message handlers

BOOL CAddChapterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	CWnd* pWnd;
	CString csAux;
	int i;


	m_CList.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_CHECKBOXES );
	m_CList.SetItemCount(110);
	m_CList.InsertColumn( 0, "Action");
	m_CList.SetColumnWidth( 0, 90); 
	m_CList.InsertColumn( 1, "Cell Type");
	m_CList.SetColumnWidth( 1, 60);
	m_CList.InsertColumn( 2, "Entry PGC");
	m_CList.SetColumnWidth( 2, 65);
	m_CList.InsertColumn( 3, "T in VTS");
	m_CList.SetColumnWidth( 3, 60); 
	m_CList.InsertColumn( 4, "T in VMG");
	m_CList.SetColumnWidth( 4, 60); 
	m_CList.InsertColumn( 5, "Cells");
	m_CList.SetColumnWidth( 5, 40);
	m_CList.InsertColumn( 6, "Progs");
	m_CList.SetColumnWidth( 6, 40); 
	m_CList.InsertColumn( 7, "Chap");
	m_CList.SetColumnWidth( 7, 40); 
	m_CList.InsertColumn( 8, "PGC Duration");
	m_CList.SetColumnWidth( 8, 77);
	m_CList.InsertColumn( 9, "Last Chapter");
	m_CList.SetColumnWidth( 9, 77);

	m_ComboNum.ResetContent();

	for (i=1; i<100 ; i++)
	{
		csAux.Format(_T("%d"),i);
		m_ComboNum.AddString(csAux);
	}
	m_ComboNum.SetCurSel(0);

	UpdateData(FALSE);

	pWnd = GetDlgItem(IDOK);
	pWnd->EnableWindow(FALSE);

	//ToolTips
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Use this to start process");
	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Use this for...quitting" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONOUTPUT), "Selects a folder for VMG and VTS IFOs backup" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONINPUT), "Selects input VTS IFO file" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONCUSTOM), "Selects custom cell in a VOB file" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONAUTO), "Checks all PGCs with Last chapter longer than 1 sec." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKAPPEND), "Appends new cells to last VOB (Beware: No VOB backup is done). Otherwise creates a new file." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKONECELL), "Uses the same blank cell in all PGCs. Otherwise one cell per each new Chapter" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKPUOPS), "Removes PUOPs in VMG and IFO: Menu-PGCs and Title-PGCs." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKBACKUP), "Check this to backup your IFOs before being modified." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_COMBONUM), "Select the number of chapters to be added." );

	DragAcceptFiles(TRUE);

	OnCheckbackup();
	
	if ( __argc == 2 ) 
	{
		m_csEditinput.Format(_T("%s"),(__argv[1]));
		NewIFOFile();
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAddChapterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAddChapterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAddChapterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CAddChapterDlg::OnButtoninput() 
{
	// TODO: Add your control notification handler code here
	CString	csFiltro,csTitulo;
//	CString	csAux,csAux1;


	// String del filtro de ficheros y del titulo
	UpdateData (TRUE);

	csFiltro = "IFO VTS files";
	csFiltro += " (*.IFO)|*.IFO||";
	csTitulo = "Select IFO Video Title Set";
	// OpenFile Dlg construction 
	CFileDialog dlgAbrir(TRUE,"IFO",NULL,OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;

	if (dlgAbrir.DoModal() == IDOK)
	{
		m_csEditinput = dlgAbrir.GetPathName(); 
		m_csEditinput.MakeUpper();
		NewIFOFile();
	}

}

void CAddChapterDlg::NewIFOFile()
{ 
	CString csAux,csAux1;
	CWnd* pWnd;
	
	
	csAux=m_csEditinput.Right(12);
	csAux1=csAux.Left(4);
	csAux=m_csEditinput.Right(6);
	if ( csAux!="_0.IFO" || csAux1 != "VTS_" )
	{
		MessageBox( "Invalid input file!", "Error",  MB_OK | MB_ICONEXCLAMATION );
		m_csEditinput="";
		m_csEditvideo="";
		return;
	}

	theApp.IniMembers();

	m_csEditinput.MakeUpper();
	theApp.m_csInputIFO=m_csEditinput;
	theApp.m_csInputPath=m_csEditinput.Left(m_csEditinput.ReverseFind('\\'));

	if (theApp.ReadIFOs() !=0) 
	{
		theApp.IniMembers();
		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(FALSE);
		return;
	}

	pWnd = GetDlgItem(IDOK);
	pWnd->EnableWindow(TRUE);

	GenerateList();
	RefreshList();
	theApp.FillSimpleVob();
	m_csEditvideo=theApp.VideoAttr();

	UpdateData (FALSE);
}		



void CAddChapterDlg::OnButtoncustom() 
{

	// TODO: Add your control notification handler code here
	CString	csFiltro,csTitulo;
	CString	csAux,csAux1;
	struct  _stati64 statbuf;



	// String del filtro de ficheros y del titulo
	UpdateData (TRUE);

	csFiltro = "VOB files";
	csFiltro += " (*.VOB)|*.VOB||";
	csTitulo = "Select Custom Cell in a VOB file";
	// OpenFile Dlg construction 
	CFileDialog dlgAbrir(TRUE,"VOB",NULL,OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;

	if (dlgAbrir.DoModal() == IDOK)
	{
		m_csEditcustom = dlgAbrir.GetPathName(); 
		m_csEditcustom.MakeUpper();

		csAux=m_csEditcustom.Right(6);
		if ( csAux!="_1.VOB" || _stati64 ( m_csEditcustom, &statbuf)!=0)
		{
			MessageBox( "Invalid input file!", "Error",  MB_OK | MB_ICONEXCLAMATION );
			m_csEditcustom="";
		}
		else 
		{
			theApp.m_i64CustomSize=(statbuf.st_size/2048);
			if ((statbuf.st_size%2048) !=0)
			{
				MessageBox( "Invalid input file!", "Error",  MB_OK | MB_ICONEXCLAMATION );
				m_csEditcustom="";
			}
		}


		theApp.m_csCellPath=m_csEditcustom;

		UpdateData (FALSE);
	}		
}


void CAddChapterDlg::GenerateList()
{

	int nPGC;

	m_CList.DeleteAllItems();


	for (nPGC=0; nPGC < theApp.m_nPGCs ; nPGC++)
	{
		m_CList.InsertItem(nPGC, "Add Chapter");
	}


}
void CAddChapterDlg::RefreshList()
{
	int nPGC;
	CString csAux;



	for (nPGC=0; nPGC < theApp.m_nPGCs ; nPGC++)
	{
//		m_CList.InsertItem(nPGC, "Add Chapter");

		// Cell Type
		if (m_CList.GetCheck(nPGC))
		{
			if (theApp.m_iCellType[nPGC]==0)
				csAux="Blank";
			else
				csAux="Custom";
		}
		else
			csAux="None";
		m_CList.SetItemText(nPGC,1, csAux);


		// PGC type
		if (theApp.m_bEntryPGC[nPGC])
			csAux="Yes";
		else
			csAux="No";
		m_CList.SetItemText(nPGC,2, csAux);

		// in VTS
		csAux.Format(_T("%02d"),theApp.m_nInVTS[nPGC]);
		m_CList.SetItemText(nPGC,3, csAux);

		// in VMG
		csAux.Format(_T("%02d"),theApp.m_nInVMG[nPGC]);
		m_CList.SetItemText(nPGC,4, csAux);

		// Cells
		csAux.Format(_T("%02d"),theApp.m_nCells[nPGC]);
		m_CList.SetItemText(nPGC,5, csAux);

		// Programs
		csAux.Format(_T("%02d"),theApp.m_nPrograms[nPGC]);
		m_CList.SetItemText(nPGC,6, csAux);

		// Chaps
		csAux.Format(_T("%02d"),theApp.m_nChapters[nPGC]);
		m_CList.SetItemText(nPGC,7, csAux);

		// Durations
		csAux=FormatDuration(theApp.m_dwDuration[nPGC]);
		m_CList.SetItemText(nPGC,8, csAux);

		// Duration Last Chapter
		csAux=FormatDuration(theApp.m_dwDurationLC[nPGC]);
		m_CList.SetItemText(nPGC,9, csAux);



	}
	UpdateData(FALSE);
}

void CAddChapterDlg::OnButtonoutput() 
{
	// TODO: Add your control notification handler code here

	CString	csPath;
	
	UpdateData (TRUE);
	csPath=SelectFolder ("Select destination Folder");
	if (! csPath.IsEmpty())
	{
		m_csEditoutput= csPath;
		m_csEditoutput.MakeUpper();
		theApp.m_csBackupPath=m_csEditoutput;
	}


	UpdateData (FALSE);
	RefreshList();

}


void CAddChapterDlg::OnButtonauto() 
{
	// TODO: Add your control notification handler code here
	int nPGC;

	for (nPGC=0; nPGC < theApp.m_nPGCs ; nPGC++)
	{

		if (DurationInSecs(theApp.m_dwDurationLC[nPGC]) > 0)
			m_CList.SetCheck(nPGC,TRUE);
		else
			m_CList.SetCheck(nPGC,FALSE);

	}
	UpdateData (FALSE);

	RefreshList();

}

void CAddChapterDlg::OnOK() 
{
	// TODO: Add extra validation here
	CString csAux,csAux1;
	int nPGC;
	CWnd* pWnd;
	bool	bAtLeastOne, bAtLeastOneCustom,bAtLeastOneBlank;
	int iRet;
	struct  _stati64 statbuf;
	int iNavPTS0,iNavPTS1;
	uchar  buffer[2050];
	FILE *in;


	UpdateData(TRUE);
	theApp.m_nChaptersToAdd=m_ComboNum.GetCurSel()+1;

	bAtLeastOne=bAtLeastOneBlank=bAtLeastOneCustom=false;
	for (nPGC=0 ; nPGC < theApp.m_nPGCs ; nPGC++)
	{
		theApp.m_BAdd[nPGC]=m_CList.GetCheck(nPGC);
		theApp.m_i64CellSize[nPGC]=0;
		if (m_CList.GetCheck(nPGC)==TRUE) 
		{
			bAtLeastOne=true;
			theApp.m_i64CellSize[nPGC]=5;
			if (theApp.m_iCellType[nPGC]==1)
			{
				bAtLeastOneCustom=true;
				theApp.m_i64CellSize[nPGC]=theApp.m_i64CustomSize;
			}
			else
				bAtLeastOneBlank=true;
		}

		if (theApp.m_BAdd[nPGC])
		{
			if (theApp.m_nPrograms[nPGC] + theApp.m_nChaptersToAdd > 255)
			{
				MessageBox( "Max number of programs (255) cannot be exceded!", "Error",  MB_OK | MB_ICONEXCLAMATION );
				return;
			}
		}
	}
	theApp.m_bAtLeastOneBlank=bAtLeastOneBlank;
	theApp.m_bAtLeastOneCustom=bAtLeastOneCustom;

	if (bAtLeastOne ==false)
	{
		MessageBox( "Check at least one PGC to process!", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	if (bAtLeastOneCustom && m_csEditcustom.IsEmpty())
	{
		MessageBox( "Fill custom cell path!", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	if (bAtLeastOneCustom)
	{
		if (  _stati64 ( m_csEditcustom, &statbuf)!=0)
		{
			MessageBox( "Invalid input file!", "Error",  MB_OK | MB_ICONEXCLAMATION );
			return;
		}

		theApp.m_i64CustomSize=(statbuf.st_size/2048);
		if ((statbuf.st_size%2048) !=0)
		{
			MessageBox( "Invalid input file!", "Error",  MB_OK | MB_ICONEXCLAMATION );
			return;
		}

		in=fopen(m_csEditcustom,"rb");
		if (in ==NULL )
		{
			MessageBox( "Invalid input file!", "Error",  MB_OK | MB_ICONEXCLAMATION );
			return;
		}

		if (readbuffer(buffer,in) == 2048)
		{
			if (IsNav (buffer))
			{
				iNavPTS0= (int) GetNbytes(4,&buffer[0x39]);
				iNavPTS1= (int) GetNbytes(4,&buffer[0x3d]);
				theApp.m_iCustomPTSDuration=iNavPTS1-iNavPTS0;
			}

		}
		fclose(in);
	}
		
	if (m_csEditinput.IsEmpty())
	{
		MessageBox( "Fill input file!", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}

	if (m_checkbackup)
	{
		if (m_csEditoutput.IsEmpty())
		{
			MessageBox( "Fill Backup Folder!", "Error",  MB_OK | MB_ICONEXCLAMATION );
			return;
		}
		if (theApp.m_csInputPath==theApp.m_csBackupPath)
		{
			MessageBox( "Output Folder must be different from input one!", "Error",  MB_OK | MB_ICONEXCLAMATION );
			return;
		}
	}
	else
	{
		iRet=MessageBox( "You are going to modify your IFOs without doing a backup.\nDo you want to continue?", "Question",  MB_YESNO | MB_ICONQUESTION );
		if (iRet!=IDYES)
			return;
	}


	csAux=m_csEditinput.Right(12);
	csAux1=csAux.Left(4);
	csAux=m_csEditinput.Right(6);
	if ( csAux!="_0.IFO" || csAux1 != "VTS_" )
	{
		MessageBox( "Invalid input file!", "Error",  MB_OK | MB_ICONEXCLAMATION );
		m_csEditinput.Empty();
		UpdateData (FALSE);
		return;
	}

	pWnd = GetDlgItem(IDOK);
	pWnd->EnableWindow(FALSE);

	theApp.m_csInputIFO=m_csEditinput;
	theApp.m_csInputPath=m_csEditinput.Left(m_csEditinput.ReverseFind('\\'));
	theApp.m_csBackupPath=m_csEditoutput;

	theApp.m_checkappend=m_checkappend;
	theApp.m_checkpuops=m_checkpuops;
	theApp.m_checkonecell=m_checkonecell;


	if (m_checkbackup)
	{
		if (theApp.BackupIFOs()!= 0)
		{
			MessageBox( "Error Backingup files", "Error",  MB_OK | MB_ICONEXCLAMATION );
			return;
		}
	}

	if (theApp.ProcessIFO()!=0)
	{
		MessageBox( "Error Processing VTS IFO", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	if (theApp.ProcessVMG()!=0)
	{
		MessageBox( "Error Processing VMG IFO", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}

	if (theApp.WriteIFOs()!=0)
	{
		MessageBox( "Error Writing IFOs", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}

	if (theApp.ProcessVOB()!=0)
	{
		MessageBox( "Error Processing VOB", "Error",  MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	
	MessageBox( "Finished Succesfully!", "Info",  MB_OK | MB_ICONINFORMATION );

	RefreshList();
	
	return;
	CDialog::OnOK();
}

void CAddChapterDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}


void CAddChapterDlg::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	*pResult = 0;
//	MessageBox( "click!", "Info",  MB_OK | MB_ICONINFORMATION );

}

void CAddChapterDlg::OnDblclkList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	int nItem;
	POSITION posPGC;
	CString csAux;
	int nResponse;
	CCustomCellDlg dlg;


	posPGC=m_CList.GetFirstSelectedItemPosition();

	if (posPGC != NULL)
	{
		nItem=m_CList.GetNextSelectedItem(posPGC);
//		csAux.Format(_T("Selected PGC # %d"),nItem);
		m_CList.SetCheck(nItem,TRUE);

		dlg.m_nPGC=nItem;

		nResponse = dlg.DoModal();
		if (nResponse == IDOK)
		{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
		}
		else if (nResponse == IDCANCEL)
		{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
		}
	}
//	else
//		csAux= "None selected";
//	MessageBox( csAux, "Info",  MB_OK | MB_ICONINFORMATION );
	RefreshList();

	UpdateData(FALSE);
	*pResult = 0;

}

void CAddChapterDlg::OnItemchangedList(NMHDR* pNMHDR, LRESULT* pResult) 
{
//	int nItem;
//	POSITION posPGC;

	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
//	posPGC=m_CList.GetFirstSelectedItemPosition();

//	if (posPGC != NULL)
//	{
//		nItem=m_CList.GetNextSelectedItem(posPGC);
//		csAux.Format(_T("Selected PGC # %d"),nItem);
//		if(m_CList.GetCheck(nItem)==FALSE)
//		{
//			theApp.m_csCellPath[nItem]="None";
//		}
//	}
	RefreshList();
	*pResult = 0;
}

void CAddChapterDlg::OnCheckbackup() 
{
	CWnd *pWnd;
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	pWnd = GetDlgItem(IDC_EDITOUTPUT);

	if (m_checkbackup==TRUE)
		pWnd->EnableWindow(TRUE);
	else
		pWnd->EnableWindow(FALSE);

	pWnd = GetDlgItem(IDC_BUTTONOUTPUT);
	if (m_checkbackup==TRUE)
		pWnd->EnableWindow(TRUE);
	else
		pWnd->EnableWindow(FALSE);
}


void CAddChapterDlg::OnDropFiles( HDROP hDropInfo)
{
	UINT nFiles;
	CWinApp* pApp;
	TCHAR szFileName[_MAX_PATH];
	CString csAux;

	SetActiveWindow();      // activate us first !
	POINT ThePoint;

	DragQueryPoint(hDropInfo,&ThePoint);

	nFiles = ::DragQueryFile(hDropInfo, (UINT)-1, NULL, 0);
	pApp = AfxGetApp();
	ASSERT(pApp != NULL);
	if(nFiles> 1)
	{
		MessageBox( "Only one file at a time!.", "Error",  MB_OK | MB_ICONEXCLAMATION );
	}
	else if(nFiles== 1)
	{
		::DragQueryFile(hDropInfo, 0, szFileName, _MAX_PATH);

		csAux =  szFileName; 
		csAux.MakeUpper();
		csAux=csAux.Right(4);

		if (csAux==".IFO")
		{
			m_csEditinput =  szFileName; 
			UpdateData (FALSE);
			NewIFOFile();
		}
		else
			MessageBox( "Please drag & drop an IFO file!.", "Error",  MB_OK | MB_ICONEXCLAMATION );
	}
	::DragFinish(hDropInfo);
}
