// CustomCellDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ToolTipDialog.h"
#include "AddChapter.h"
#include "CustomCellDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern CAddChapterApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CCustomCellDlg dialog


CCustomCellDlg::CCustomCellDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CCustomCellDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCustomCellDlg)
	m_iCellType = 0;
	//}}AFX_DATA_INIT
}


void CCustomCellDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCustomCellDlg)
	DDX_Control(pDX, IDC_COMBOSTILL, m_Combostill);
	DDX_Radio(pDX, IDC_RADIO1, m_iCellType);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCustomCellDlg, CDialog)
	//{{AFX_MSG_MAP(CCustomCellDlg)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CCustomCellDlg::OnInitDialog()
{
//	CWnd* pWnd;
	int i;
	CString csAux;

	CDialog::OnInitDialog();

	m_Combostill.ResetContent();

	for (i=0; i<256 ; i++)
	{
		csAux.Format(_T("%d"),i);
		m_Combostill.AddString(csAux);
	}

	m_iCellType=theApp.m_iCellType[m_nPGC];
	m_Combostill.SetCurSel(theApp.m_iStillTime[m_nPGC]);

	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Use this to accept");
	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Use this for cancel" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_COMBOSTILL), "Select time in secs of still. 255 means infinite" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_RADIO1), "Selects a blank cell" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_RADIO2), "Selects a custom sell (still)" );
	

	UpdateData(FALSE);

	EnableControls();
	return TRUE;  // return TRUE  unless you set the focus to a control

}
/////////////////////////////////////////////////////////////////////////////
// CCustomCellDlg message handlers


void CCustomCellDlg::EnableControls() 
{
	CWnd* pWnd;

	UpdateData(TRUE);
	if (m_iCellType==0)
	{
		pWnd = GetDlgItem(IDC_COMBOSTILL);
		pWnd->EnableWindow(FALSE);
		m_Combostill.SetCurSel(0);
		theApp.m_iStillTime[m_nPGC]=0;
	}
	else
	{
		pWnd = GetDlgItem(IDC_COMBOSTILL);
		pWnd->EnableWindow(TRUE);
	}
}

void CCustomCellDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CCustomCellDlg::OnOK() 
{
	// TODO: Add extra validation here
	theApp.m_iStillTime[m_nPGC]=m_Combostill.GetCurSel();
	theApp.m_iCellType[m_nPGC]=m_iCellType;

	CDialog::OnOK();
}

void CCustomCellDlg::OnRadio() 
{
	// TODO: Add your control notification handler code here
EnableControls() ;	
}
